// drawwnd.cpp : implementation file
//

#include "stdafx.h"
#include "Saver.h"
#include "drawwnd.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

LPCTSTR CDrawWnd::m_lpszClassName = NULL;

int letterM[][3] =
{
	{0,0,0}, {0,8,1}, {3,5,1}, {6,8,1}, {6,0,1}
};

int letterC1[][3] =
{
	{6,0,0}, {0,0,1}, {0,4,1}, {0,8,1}, {6,8,1}
};

int letterF[][3] =
{
	{0,0,0}, {0,8,1}, {6,8,1}, {0,4,0}, {2,4,1}, {4,4,1}
};

int letterPlus[][3] =
{
	{3,0,0}, {3,4,1}, {3,8,1}, {0,4,0}, {3,4,1}, {6,4,1}
};

int letterC2[][3] =
{
	{6,0,0}, {0,0,1}, {0,4,1}, {0,4,0}, {0,8,1}, {6,8,1}
};

/////////////////////////////////////////////////////////////////////////////
// CDrawWnd

CDrawWnd::CDrawWnd(BOOL bAutoDelete)
{
	m_bAutoDelete = bAutoDelete;
	m_nPos = 0;
	m_nStep = 1;
	m_rgnLast.CreateRectRgn(0,0,0,0);

	m_nWidth = AfxGetApp()->GetProfileInt("Config", "Width", 10);
	m_nSteps = AfxGetApp()->GetProfileInt("Config", "Resolution", 10);
	m_nStyle = AfxGetApp()->GetProfileInt("Config", "Style", PS_ENDCAP_ROUND|PS_JOIN_ROUND);
	if (m_nSteps < 1)
		m_nSteps = 1;
	m_logbrush.lbStyle = m_logbrushBlack.lbStyle = BS_SOLID;
	m_logbrush.lbHatch = m_logbrushBlack.lbHatch = 0;
	m_logbrush.lbColor = RGB(
		AfxGetApp()->GetProfileInt("Config", "ColorRed", 255),
		AfxGetApp()->GetProfileInt("Config", "ColorGreen", 0),
		AfxGetApp()->GetProfileInt("Config", "ColorBlue", 0));
	m_logbrushBlack.lbColor = RGB(0, 0, 0); 
	  srand( (unsigned)time( NULL ) );
}

CDrawWnd::~CDrawWnd()
{
}


BEGIN_MESSAGE_MAP(CDrawWnd, CWnd)
	//{{AFX_MSG_MAP(CDrawWnd)
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CDrawWnd::DrawLetter(CDC* dc, CPoint pt, int p1[][3], 
	int p2[][3], int nLen)
{
	
/*	for (int i=0;i<nLen;i++)
	{
		int x = (m_nScale*p1[i][0]*(m_nSteps-m_nPos) + m_nScale*p2[i][0]*m_nPos)/m_nSteps;
		int y = (m_nScale*p1[i][1]*(m_nSteps-m_nPos) + m_nScale*p2[i][1]*m_nPos)/m_nSteps;
		if (p1[i][2] == 0)
			dc.MoveTo(pt.x+x, pt.y-y);
		else
			dc.LineTo(pt.x+x, pt.y-y);z
	} */
	CFont blah;
    blah.CreateFont(32, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE, 0, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
	CFont *oldfont = dc->SelectObject(&blah);
	dc->TextOut(50,50, "blah");
	dc->SelectObject(oldfont);

}
void CDrawWnd::DrawImage(CDC* dc, UINT refnum, int x, int y, DWORD dwrop)
{
	    CBitmap theimage;
		CDC ndc;
		 BOOL err1 = ndc.CreateCompatibleDC(dc);
		BOOL err3 =  theimage.LoadBitmap(refnum );
		 BITMAP pbitmap;
		if (err3 == 1)
		{
			theimage.GetBitmap(&pbitmap);
			int theimagewidth = pbitmap.bmWidth;
			int theimageheight = pbitmap.bmHeight;
			if (x == -1) 
			{ x = m_nWidth / 2 - theimagewidth / 2;	}
			if (y == -1) 
			{ y = m_nHeight / 2 - theimageheight / 2;	}
			
			CBitmap* oldbitmap = ndc.SelectObject(&theimage); 
			if (dwrop == PATCOPY)
			{
				int nx = (int) ( m_nWidth  / theimagewidth) + 1;
			//	nx = 5;
				int ny = (int) ( m_nHeight  / theimageheight) + 1;
			//	ny = 5;
				int nxi, nyi;
				for (nxi = 0; nxi < nx; nxi += 1)
					for (nyi = 0; nyi < ny; nyi += 1)
					{
					   dc->BitBlt(nxi*theimagewidth,nyi*theimageheight,((nxi+1)*(theimagewidth)), ((nyi+1)*(theimageheight)),&ndc, 0,0, SRCCOPY); 
					}
			}
			else
			  int err2 = dc->BitBlt(x,y,x+theimagewidth,y+theimageheight,&ndc, 0,0, dwrop ); 
			ndc.SelectObject(oldbitmap);
			theimage.DeleteObject();  
		} 
}

void CDrawWnd::Draw(CDC* dc, int nWidth) 
{
/*	dc.SetPolyFillMode(WINDING);

	CPen penblack(PS_SOLID|PS_GEOMETRIC|m_nStyle, nWidth, &m_logbrushBlack);
	CPen penred(PS_SOLID|PS_GEOMETRIC|m_nStyle, nWidth, &m_logbrush);
	CBrush brushBlack(m_logbrushBlack.lbColor);
	CBrush brushRed(m_logbrush.lbColor);
	CRgn rgnNew, rgnBlack;

	CPen* pPen = dc.SelectObject(&penred); */

	//dc.BeginPath();
	// letters are 7x9
	// allow 2 units for spacing

/*	CPoint pt(2*m_nScale, m_nHeight/2+(9*m_nScale)/2); 
	DrawLetter(&dc, pt, letterM, letterC1, 5);
	 pt.x += 9*m_nScale;
	DrawLetter(&dc, pt, letterF, letterPlus, 6);
	pt.x += 9*m_nScale;
	DrawLetter(&dc, pt, letterC2, letterPlus, 6);

	dc.EndPath();
	dc.WidenPath();
	rgnNew.CreateFromPath(&dc); 

	rgnBlack.CreateRectRgn(0,0,0,0);
	rgnBlack.CombineRgn(&m_rgnLast, &rgnNew, RGN_DIFF);
	dc.FillRgn(&rgnBlack, &brushBlack);
	dc.FillRgn(&rgnNew, &brushRed); */

	/* dc.SelectObject(pPen);
	m_rgnLast.DeleteObject();
	m_rgnLast.Attach(rgnNew.Detach()); */

	// double rotationAngle = 0;
	double angle1, angle2, angle3;
	int thecase,xz;
	char tmpchrbuf[50];
	int x;
	RECT temprect;
	RECT rect1, rect2, rect3;	
	CSize tempsize;
	tempsize.cx = m_nWidth;
	tempsize.cy = m_nHeight;
	//tempsize.cx = 1024;
	//tempsize.cy = 768;
	temprect.left = 0;
	temprect.top = 0;
	temprect.right = tempsize.cx;
	temprect.bottom = tempsize.cy;
	dc->SetBkMode(TRANSPARENT);
	dc->FillSolidRect(&temprect,0x00000000);
	long int textcolor = 0x00000000 + ((rand()% 0xFF) << 16) + ((rand() % 0xFF) << 8) + (rand() % 0xFF);
	dc->SetTextColor(textcolor);
	dc->SetBkColor(0x00000000);
	m_haiku2->makehaiku();
		CFont blah;
	    // blah.CreateFont(2*m_nScale, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE, 0, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
	blah.CreateFont(2*m_nScale, 0, 0, 0, 0, 0,0,0,0,OUT_DEVICE_PRECIS, CLIP_LH_ANGLES, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
	CFont *oldfont = dc->SelectObject(&blah);
	// dc->TextOut(50,50, " FUCK ");	
	rect1.top = rect1.bottom = rect1.left = rect2.top = rect2.bottom = rect2.left = rect3.top = rect2.bottom= rect3.left = 0;
	int textheight1 =  dc->DrawText(*(m_haiku2->m_line1), &rect1, DT_CALCRECT);
	int textheight2 =  dc->DrawText(*(m_haiku2->m_line2), &rect2, DT_CALCRECT);
	int textheight3 =  dc->DrawText(*(m_haiku2->m_line3), &rect3, DT_CALCRECT);
	sprintf(tmpchrbuf, "x: %i, y: %i", tempsize.cx, tempsize.cy);
	// dc->TextOut(50,50, tmpchrbuf);
	dc->SelectObject(oldfont);
	angle1 = angle2 = angle3 = 0;
	switch ((thecase = (rand() % 5)))
//	switch ((thecase = 4))
	{
	case 4:
		switch ((rand() % 4))
		{
		case 0: // props
			DrawImage(dc, 200,-1, -1, SRCCOPY);
			break;
		case 1: // dancing fat kid
		    dc->FillSolidRect(&temprect,0xffffffff);
			DrawImage(dc, IDB_FATGUY1,-1, -1, SRCCOPY);
			Sleep(250);
			DrawImage(dc, IDB_FATGUY2,-1, -1, SRCCOPY);
			Sleep(250);
			DrawImage(dc, IDB_FATGUY3,-1, -1, SRCCOPY);
			Sleep(250);
			DrawImage(dc, IDB_FATGUY4,-1, -1, SRCCOPY);
			Sleep(250);
			DrawImage(dc, IDB_FATGUY5,-1, -1, SRCCOPY);
			Sleep(400);
			break;
		case 2:
		    dc->FillSolidRect(&temprect,0xffffffff);
		    for (x = 1; x < 25; x++)
			{
				DrawImage(dc, 11000+x ,-1, -1, SRCCOPY);
				Sleep(400);
			}
		    Sleep(400);
			break; 
		case 3:
		    dc->FillSolidRect(&temprect,0xffffffff);
		    for (x = 1; x < 13; x++)
			{
				DrawImage(dc, 10000+x ,-1, -1, SRCCOPY);
				Sleep(250); 
			}
		    Sleep(400);
		    break; 
		}
		break;
	case 0: /* center the 3 */
			rect1.top = (int) tempsize.cy / 4; rect2.top = (int) tempsize.cy / 2; rect3.top = (int) tempsize.cy / 4 * 3;
			rect1.top -= (int) rect1.bottom / 2; rect2.top -= (int) rect2.bottom / 2; rect3.top -= (int) rect3.bottom / 2;
			rect1.bottom += (int) rect1.top; rect2.bottom += (int) rect2.top; rect3.bottom += (int) rect3.top;
			rect1.left = (int) (tempsize.cx / 2) - (rect1.right / 2);
			rect2.left = (int) (tempsize.cx / 2) - (rect2.right / 2);
			rect3.left = (int) (tempsize.cx / 2) - (rect3.right / 2);
			rect3.right += rect3.left;
			angle1 = angle2 = angle3 = 0;
	    	DrawImage(dc, (int) (rand() % (13))+9000, 50, 50, PATCOPY);
			break;
	case 3:
	case 2:
	case 1:
		/* determine maximum angles we can use for text boxes */
			angle1 = (180 / 3.141) * asin((((double) (tempsize.cy-textheight1)) / 2)/rect1.right);
			angle3 = (180 / 3.141) * asin((((double) (tempsize.cy-textheight2-(textheight3*2))) / 2)/rect3.right);
			if ((angle3 < angle1) && (thecase == 1))
			{	angle1 = angle3;
			angle2 = 0; angle3 = angle1;
			}
			angle3 *= -1;
			rect2.top = (int) tempsize.cy / 2;
			rect2.bottom += (int) rect2.top;
			rect2.left = 0;
			rect3.left =(int) ( -1 * (sin(angle3 * 3.141 / 180) * textheight3));
			rect1.top = rect2.top - textheight1; rect3.top = rect2.top + textheight2;
			if (thecase == 2)
			{   /* shift it over to the right */
				rect3.left = tempsize.cx - rect3.right; rect3.right = tempsize.cx;
			}
			DrawImage(dc, (int) (rand() % (13))+9000, 50, 50, PATCOPY);
			break;
	}
	// line 1
	if (thecase != 4)
	{	
		dc->SetTextColor(0xFFFFFFFF - textcolor);
		CFont blah1b;
		int fonterror1b = blah1b.CreateFont(2*m_nScale, 0, (int) (angle1*10), 0, 0, 0,0,0,0,OUT_DEVICE_PRECIS, CLIP_LH_ANGLES, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
		CFont *oldfont1b = dc->SelectObject(&blah1b);
		rect1.left -= 1;
		dc->DrawText(*(m_haiku2->m_line1), &rect1, DT_NOCLIP);
		rect1.left += 2;
		dc->DrawText(*(m_haiku2->m_line1), &rect1, DT_NOCLIP);
		rect1.left -= 1;
		rect1.top -= 1;
		dc->DrawText(*(m_haiku2->m_line1), &rect1, DT_NOCLIP);
		rect1.top += 2;
		dc->DrawText(*(m_haiku2->m_line1), &rect1, DT_NOCLIP);
		rect1.top -= 1;
		dc->SelectObject(oldfont1b);
		dc->SetTextColor(textcolor);
		CFont blah1;
		int fonterror1 = blah1.CreateFont(2*m_nScale, 0, (int) (angle1*10), 0, 0, 0,0,0,0,OUT_DEVICE_PRECIS, CLIP_LH_ANGLES, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
		CFont *oldfont1 = dc->SelectObject(&blah1);
		dc->DrawText(*(m_haiku2->m_line1), &rect1, DT_NOCLIP);
		dc->SelectObject(oldfont1);
		CFont blah2;
		dc->SetTextColor(0xFFFFFFFF - textcolor);
		CFont blah2b;
		int fonterror2b = blah2b.CreateFont(2*m_nScale, 0, (int) (angle2*10), 0, 0, 0,0,0,0,OUT_DEVICE_PRECIS, CLIP_LH_ANGLES, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
		CFont *oldfont2b = dc->SelectObject(&blah2b);
		rect2.left -= 1;
		dc->DrawText(*(m_haiku2->m_line2), &rect2, DT_NOCLIP);
		rect2.left += 2;
		dc->DrawText(*(m_haiku2->m_line2), &rect2, DT_NOCLIP);
		rect2.left -= 1;
		rect2.top -= 1;
		dc->DrawText(*(m_haiku2->m_line2), &rect2, DT_NOCLIP);
		rect2.top += 2;
		dc->DrawText(*(m_haiku2->m_line2), &rect2, DT_NOCLIP);
		rect2.top -= 1;
		dc->SelectObject(oldfont2b);
		dc->SetTextColor(textcolor);
		int fonterror2 = blah2.CreateFont(2*m_nScale, 0, (int) (angle2*10), 0, 0, 0,0,0,0,OUT_DEVICE_PRECIS, CLIP_LH_ANGLES, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
		CFont *oldfont2 = dc->SelectObject(&blah2);
		dc->DrawText(*(m_haiku2->m_line2), &rect2,  DT_NOCLIP);
		dc->SelectObject(oldfont2);
		dc->SetTextColor(0xFFFFFFFF - textcolor);
		CFont blah3b;
		int fonterror3b = blah3b.CreateFont(2*m_nScale, 0, (int) (angle3*10), 0, 0, 0,0,0,0,OUT_DEVICE_PRECIS, CLIP_LH_ANGLES, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
		CFont *oldfont3b = dc->SelectObject(&blah3b);
		rect3.left -= 1;
		dc->DrawText(*(m_haiku2->m_line3), &rect3, DT_NOCLIP);
		rect3.left += 2;
		dc->DrawText(*(m_haiku2->m_line3), &rect3, DT_NOCLIP);
		rect3.left -= 1;
		rect3.top -= 1;
		dc->DrawText(*(m_haiku2->m_line3), &rect3, DT_NOCLIP);
		rect3.top += 2;
		dc->DrawText(*(m_haiku2->m_line3), &rect3, DT_NOCLIP);
		rect3.top -= 1;
		dc->SelectObject(oldfont3b);
		dc->SetTextColor(textcolor);
		CFont blah3;
		int fonterror3 = blah3.CreateFont(2*m_nScale, 0, (int) (angle3*10), 0, 0, 0,0,0,0,OUT_DEVICE_PRECIS, CLIP_LH_ANGLES, DEFAULT_QUALITY, DEFAULT_PITCH, NULL);
		CFont *oldfont3 = dc->SelectObject(&blah3);
		dc->DrawText(*(m_haiku2->m_line3), &rect3,  DT_NOCLIP);
		dc->SelectObject(oldfont3);
		}
	// stuff below works

	// -----
}

void CDrawWnd::SetSpeed(int nSpeed)
{
	KillTimer(1);
	VERIFY(SetTimer(1, (50+500-nSpeed*5)*10, NULL) != 0);
}

void CDrawWnd::SetResolution(int nRes)
{
	nRes = (nRes < 1) ? 1 : nRes;
	if (nRes != m_nSteps)
	{
		m_nSteps = nRes;
		if (m_nPos > m_nSteps)
			m_nPos = m_nSteps;
		Invalidate();
		UpdateWindow();
	}
}

void CDrawWnd::SetPenWidth(int nWidth)
{
	if (nWidth != m_nWidth)
	{
		CRect rect;
	//	m_nWidth = nWidth;
		Invalidate();
		UpdateWindow();
	}
}

void CDrawWnd::SetColor(COLORREF cr)
{
	m_logbrush.lbColor = cr;
}

void CDrawWnd::SetLineStyle(int nStyle)
{
	if (nStyle != m_nStyle)
	{
		m_nStyle = nStyle;
		Invalidate();
		UpdateWindow();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDrawWnd message handlers

void CDrawWnd::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == 1)
	{
		m_nPos += m_nStep;
		if (m_nPos > m_nSteps || m_nPos < 0)
		{
			m_nStep = -m_nStep;
			m_nPos += m_nStep;
		}
		CClientDC dc(this);
		CRect rect;
		GetClientRect(&rect);
		int nWidth = m_nWidth * rect.Width() + ::GetSystemMetrics(SM_CXSCREEN)/2;
		nWidth = nWidth/::GetSystemMetrics(SM_CXSCREEN);
		Draw(&dc, nWidth);
	}
	else	
		CWnd::OnTimer(nIDEvent);
}

void CDrawWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	m_rgnLast.DeleteObject();
	m_rgnLast.CreateRectRgn(0,0,0,0);
	CBrush brush(RGB(0,0,0));
	CRect rect;
	GetClientRect(rect);
	dc.FillRect(&rect, &brush);
	int nWidth = m_nWidth * rect.Width() + ::GetSystemMetrics(SM_CXSCREEN)/2;
	nWidth = nWidth/::GetSystemMetrics(SM_CXSCREEN);
	Draw(&dc, nWidth);
	// Do not call CWnd::OnPaint() for painting messages
}

void CDrawWnd::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	m_nScale = cx/30;
	m_nHeight = cy;
	m_nWidth = cx;
}

int CDrawWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	int nSpeed = AfxGetApp()->GetProfileInt("Config", "Speed", 1);
	if (nSpeed < 0)
		nSpeed = 0;	
	SetSpeed(nSpeed);

	return 0;
}

BOOL CDrawWnd::Create(DWORD dwExStyle, DWORD dwStyle, const RECT& rect, 
	CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
    // Register a class with no cursor
	if (m_lpszClassName == NULL)
	{
    	m_lpszClassName = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW,
			::LoadCursor(AfxGetResourceHandle(), 
			MAKEINTRESOURCE(IDC_NULLCURSOR)));
	}

	// TODO: Add your specialized code here and/or call the base class
	return CreateEx(dwExStyle, m_lpszClassName, _T(""), dwStyle, 
		rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, 
		pParentWnd->GetSafeHwnd(), NULL, NULL );
}

void CDrawWnd::PostNcDestroy() 
{
	if (m_bAutoDelete)
		delete this;
}
